Index: IOIPSL/trunk/src/getincom.f90
===================================================================
--- IOIPSL/trunk/src/getincom.f90	(revision 10)
+++ IOIPSL/trunk/src/getincom.f90	(revision 11)
@@ -1467,18 +1206,13 @@
   ENDDO
 !-
-  CLOSE(22)
+  CLOSE(UNIT=22)
 !-
   IF (check) THEN
-    OPEN (22,file='run.def.test')
+    OPEN (UNIT=22,file='run.def.test')
     DO i=1,nb_lines
-      WRITE(22,*) targetlist(i)," : ",fichier(i)
+      WRITE(UNIT=22,FMT=*) targetlist(i)," : ",fichier(i)
     ENDDO
-    CLOSE(22)
-  ENDIF
-!-
-  RETURN
-!-
-9997 WRITE(*,*) "getin_readdef : Could not open file ", &
-          & TRIM(filelist(current))
+    CLOSE(UNIT=22)
+  ENDIF
 !---------------------------
 END SUBROUTINE getin_readdef
@@ -1496,13 +1230,13 @@
 ! ARGUMENTS
 !-
-  INTEGER :: current, nb_lastkey
-  CHARACTER(LEN=*) :: key_str, NEW_str, last_key
+  INTEGER :: current,nb_lastkey
+  CHARACTER(LEN=*) :: key_str,NEW_str,last_key
 !-
 ! LOCAL
 !-
-  INTEGER :: len_str, blk, nbve, starpos
-  CHARACTER(LEN=100) :: tmp_str, new_key, mult
-  CHARACTER(LEN=3)   :: cnt, chlen
-  CHARACTER(LEN=10)  :: fmt
+  INTEGER :: len_str,blk,nbve,starpos
+  CHARACTER(LEN=100) :: tmp_str,new_key,mult
+  CHARACTER(LEN=n_d_fmt) :: cnt
+  CHARACTER(LEN=10) :: c_fmt
 !---------------------------------------------------------------------
   len_str = LEN_TRIM(NEW_str)
@@ -1516,6 +1250,6 @@
     DO WHILE (blk > 0)
       IF (nbfiles+1 > max_files) THEN
-        WRITE(*,*) 'FATAL ERROR : Too many files to include'
-        STOP 'getin_readdef'
+        CALL ipslerr (3,'getin_decrypt', &
+ &       'Too many files to include',' ',' ')
       ENDIF
 !-----
@@ -1528,6 +1262,6 @@
 !---
     IF (nbfiles+1 > max_files) THEN
-      WRITE(*,*) 'FATAL ERROR : Too many files to include'
-      STOP 'getin_readdef'
+      CALL ipslerr (3,'getin_decrypt', &
+ &     'Too many files to include',' ',' ')
     ENDIF
 !---
@@ -1543,8 +1277,8 @@
     nb_lines = nb_lines+1
     IF (nb_lines > max_lines) THEN
-      WRITE(*,*) &
- &      'Too many line in the run.def files. You need to increase'
-      WRITE(*,*) 'the parameter max_lines in the module getincom.'
-      STOP 'getin_decrypt'
+      CALL ipslerr (3,'getin_decrypt', &
+ &     'Too many lines in the run.def files.', &
+ &     'You need to increase', &
+ &     'the parameter max_lines in the module getincom.')
     ENDIF
 !-
@@ -1556,13 +1290,9 @@
  &                    .AND.(tmp_str(1:1) /= "'") ) THEN
 !-----
-      IF (INDEX(key_str(1:len_TRIM(key_str)),'__') > 0) THEN
-        WRITE(*,*) 'ERROR : getin_decrypt'
-        WRITE(*,*) &
-&         'We can not have a compressed field of values for in a'
-        WRITE(*,*) &
-&         'vector notation. If a target is of the type TARGET__1'
-        WRITE(*,*) 'then only a scalar value is allowed'
-        WRITE(*,*) 'The key at fault : ',key_str(1:len_TRIM(key_str))
-        STOP 'getin_decrypt'
+      IF (INDEX(key_str(1:LEN_TRIM(key_str)),'__') > 0) THEN
+        CALL ipslerr (3,'getin_decrypt', &
+ &       'We can not have a compressed field of values', &
+ &       'in a vector notation (TARGET__n).', &
+ &       'The key at fault : '//TRIM(key_str))
       ENDIF
 !-
@@ -1575,10 +1305,9 @@
       blk = INDEX(NEW_str(1:len_str),' ')
       IF (blk > 1) THEN
-        WRITE(*,*) &
- &       'This is a strange behavior of getin_decrypt you could report'
-      ENDIF
-      WRITE(chlen,'(I3.3)') LEN_TRIM(mult)
-      fmt = '(I'//chlen//')'
-      READ(mult,fmt) compline(nb_lines)
+        CALL ipslerr (2,'getin_decrypt', &
+ &       'This is a strange behavior','you could report',' ')
+      ENDIF
+      WRITE (UNIT=c_fmt,FMT='("(I",I5.5,")")') LEN_TRIM(mult)
+      READ(UNIT=mult,FMT=c_fmt) compline(nb_lines)
 !---
     ELSE
@@ -1588,5 +1317,5 @@
 !-- If there is no space wthin the line then the target is a scalar
 !-- or the element of a properly written vector.
-!-- (ie of the type TARGET__1)
+!-- (ie of the type TARGET__00001)
 !-
     IF (    (blk <= 1) &
@@ -1597,14 +1326,15 @@
 !------ Save info of current keyword as a scalar
 !------ if it is not a continuation
-        targetlist(nb_lines) = key_str(1:MIN(len_trim(key_str),30))
-        last_key = key_str(1:MIN(len_trim(key_str),30))
+        targetlist(nb_lines) = key_str(1:MIN(LEN_TRIM(key_str),l_n))
+        last_key = key_str(1:MIN(LEN_TRIM(key_str),l_n))
         nb_lastkey = 1
       ELSE
 !------ We are continuing a vector so the keyword needs
 !------ to get the underscores
-        WRITE(cnt,'(I3.3)') nb_lastkey+1
+        WRITE(UNIT=cnt,FMT=c_i_fmt) nb_lastkey+1
         targetlist(nb_lines) = &
- &        key_str(1:MIN(len_trim(key_str),25))//'__'//cnt
-        last_key = key_str(1:MIN(len_trim(key_str),25))//'__'//cnt
+ &        key_str(1:MIN(LEN_TRIM(key_str),l_n-n_d_fmt-2))//'__'//cnt
+        last_key = &
+ &        key_str(1:MIN(LEN_TRIM(key_str),l_n-n_d_fmt-2))//'__'//cnt
         nb_lastkey = nb_lastkey+1
       ENDIF
@@ -1617,20 +1347,17 @@
 !---- If there are blanks whithin the line then we are dealing
 !---- with a vector and we need to split it in many entries
-!---- with the TRAGET__1 notation.
+!---- with the TARGET__n notation.
 !----
 !---- Test if the targer is not already a vector target !
 !-
       IF (INDEX(TRIM(key_str),'__') > 0) THEN
-        WRITE(*,*) 'ERROR : getin_decrypt'
-        WRITE(*,*) 'We have found a mixed vector notation'
-        WRITE(*,*) 'If a target is of the type TARGET__1'
-        WRITE(*,*) 'then only a scalar value is allowed'
-        WRITE(*,*) 'The key at fault : ',key_str(1:len_TRIM(key_str))
-        STOP 'getin_decrypt'
+        CALL ipslerr (3,'getin_decrypt', &
+ &       'We have found a mixed vector notation (TARGET__n).', &
+ &       'The key at fault : '//TRIM(key_str),' ')
       ENDIF
 !-
       nbve = nb_lastkey
       nbve = nbve+1
-      WRITE(cnt,'(I3.3)') nbve
+      WRITE(UNIT=cnt,FMT=c_i_fmt) nbve
 !-
       DO WHILE (blk > 0)
@@ -1639,6 +1366,7 @@
 !-
         fichier(nb_lines) = tmp_str(1:blk)
-        new_key =  key_str(1:MIN(len_trim(key_str),25))//'__'//cnt
-        targetlist(nb_lines) = new_key(1:MIN(len_trim(new_key),30))
+        new_key = &
+ &       key_str(1:MIN(LEN_TRIM(key_str),l_n-n_d_fmt-2))//'__'//cnt
+        targetlist(nb_lines) = new_key(1:MIN(LEN_TRIM(new_key),l_n))
         CALL gensig (targetlist(nb_lines),targetsiglist(nb_lines))
         fromfile(nb_lines) = current
@@ -1649,11 +1377,11 @@
         nb_lines = nb_lines+1
         IF (nb_lines > max_lines) THEN
-          WRITE(*,*) &
- &          'Too many line in the run.def files. You need to increase'
-          WRITE(*,*) 'the parameter max_lines in the module getincom.'
-          STOP 'getin_decrypt'
+          CALL ipslerr (3,'getin_decrypt', &
+ &         'Too many lines in the run.def files.', &
+ &         'You need to increase', &
+ &         'the parameter max_lines in the module getincom.')
         ENDIF
         nbve = nbve+1
-        WRITE(cnt,'(I3.3)') nbve
+        WRITE(UNIT=cnt,FMT=c_i_fmt) nbve
 !-
       ENDDO
@@ -1662,10 +1390,12 @@
 !-
       fichier(nb_lines) = tmp_str(1:LEN_TRIM(tmp_str))
-      new_key = key_str(1:MIN(len_trim(key_str),25))//'__'//cnt
-      targetlist(nb_lines) = new_key(1:MIN(len_trim(new_key),30))
+      new_key = &
+ &      key_str(1:MIN(LEN_TRIM(key_str),l_n-n_d_fmt-2))//'__'//cnt
+      targetlist(nb_lines) = new_key(1:MIN(LEN_TRIM(new_key),l_n))
       CALL gensig (targetlist(nb_lines),targetsiglist(nb_lines))
       fromfile(nb_lines) = current
 !-
-      last_key = key_str(1:MIN(len_trim(key_str),25))//'__'//cnt
+      last_key = &
+ &      key_str(1:MIN(LEN_TRIM(key_str),l_n-n_d_fmt-2))//'__'//cnt
       nb_lastkey = nbve
 !-
@@ -1684,12 +1414,5 @@
   IMPLICIT NONE
 !-
-! Arguments
-!-
-!-
-! LOCAL
-!-
-  INTEGER :: line,i,sig
-  INTEGER :: found
-  CHARACTER(LEN=30) :: str
+  INTEGER :: line,found
 !---------------------------------------------------------------------
   DO line=1,nb_lines-1
@@ -1706,5 +1429,5 @@
 !-----
       WRITE(*,*) &
- & 'getin_checkcohe : Found a problem on key ',targetlist(line)
+ & 'getin_checkcohe : Found a problem on key ',TRIM(targetlist(line))
       WRITE(*,*) &
  & 'getin_checkcohe : The following values were encoutered :'
@@ -1721,5 +1444,5 @@
     ENDIF
   ENDDO
-!-
+!-----------------------------
 END SUBROUTINE getin_checkcohe
 !-
@@ -1730,5 +1453,5 @@
   IMPLICIT NONE
 !-
-  INTEGER :: unit, eof, nb_lastkey
+  INTEGER :: unit,eof,nb_lastkey
   CHARACTER(LEN=100) :: dummy
   CHARACTER(LEN=100) :: out_string
@@ -1740,5 +1463,5 @@
 !-
   DO WHILE (first == "#")
-    READ (unit,'(a100)',ERR=9998,END=7778) dummy
+    READ (UNIT=unit,FMT='(A)',ERR=9998,END=7778) dummy
     dummy = TRIM(ADJUSTL(dummy))
     first=dummy(1:1)
@@ -1751,338 +1474,12 @@
   RETURN
 !-
-9998 WRITE(*,*) " GETIN_SKIPAFEW : Error while reading file "
-  STOP 'getin_skipafew'
-!-
-7778 eof = 1
+9998 CONTINUE
+  CALL ipslerr (3,'getin_skipafew','Error while reading file',' ',' ')
+!-
+7778 CONTINUE
+  eof = 1
 !----------------------------
 END SUBROUTINE getin_skipafew
 !-
-!=== INTEGER database INTERFACE
-!-
-SUBROUTINE getdbwi &
- &  (target,target_sig,status,fileorig,size_of_in,tmp_ret_val)
-!---------------------------------------------------------------------
-!- Write the INTEGER data into the data base
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  CHARACTER(LEN=*) :: target
-  INTEGER :: target_sig, status, fileorig, size_of_in
-  INTEGER,DIMENSION(:) :: tmp_ret_val
-!---------------------------------------------------------------------
-!-
-! First check if we have sufficiant space for the new key
-!-
-  IF (nb_keys+1 > keymemsize) THEN
-    CALL getin_allockeys ()
-  ENDIF
-!-
-! Fill out the items of the data base
-!-
-  nb_keys = nb_keys+1
-  keysig(nb_keys) = target_sig
-  keystr(nb_keys) = target(1:MIN(len_trim(target),30))
-  keystatus(nb_keys) = status
-  keytype(nb_keys) = 1
-  keyfromfile(nb_keys) = fileorig
-!-
-! Can we compress the data base entry ?
-!-
-  IF (     (MINVAL(tmp_ret_val) == MAXVAL(tmp_ret_val)) &
- &    .AND.(size_of_in > compress_lim)) THEN
-    keymemstart(nb_keys) = intmempos+1
-    keycompress(nb_keys) = size_of_in
-    keymemlen(nb_keys) = 1
-  ELSE
-    keymemstart(nb_keys) = intmempos+1
-    keycompress(nb_keys) = -1
-    keymemlen(nb_keys) = size_of_in
-  ENDIF
-!-
-! Before writing the actual size lets see if we have the space
-!-
-  IF (keymemstart(nb_keys)+keymemlen(nb_keys) > intmemsize) THEN
-    CALL getin_allocmem (1,keymemlen(nb_keys))
-  ENDIF
-!-
-  intmem(keymemstart(nb_keys): &
- &       keymemstart(nb_keys)+keymemlen(nb_keys)-1) = &
- &  tmp_ret_val(1:keymemlen(nb_keys))
-  intmempos = keymemstart(nb_keys)+keymemlen(nb_keys)-1
-!---------------------
-END SUBROUTINE getdbwi
-!-
-!===
-!-
-SUBROUTINE getdbri (pos,size_of_in,target,tmp_ret_val)
-!---------------------------------------------------------------------
-!- Read the required variables in the database for INTEGERS
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  INTEGER :: pos, size_of_in
-  CHARACTER(LEN=*) :: target
-  INTEGER,DIMENSION(:) :: tmp_ret_val
-!---------------------------------------------------------------------
-  IF (keytype(pos) /= 1) THEN
-    WRITE(*,*) 'FATAL ERROR : Wrong data type for keyword ',target
-    STOP 'getdbri'
-  ENDIF
-!-
-  IF (keycompress(pos) > 0) THEN
-    IF ( keycompress(pos) /= size_of_in .OR. keymemlen(pos) /= 1 ) THEN
-      WRITE(*,*) &
- &      'FATAL ERROR : Wrong compression length for keyword ',target
-      STOP 'getdbri'
-    ELSE
-      tmp_ret_val(1:size_of_in) = intmem(keymemstart(pos))
-    ENDIF
-  ELSE
-    IF (keymemlen(pos) /= size_of_in) THEN
-      WRITE(*,*) 'FATAL ERROR : Wrong array length for keyword ',target
-      STOP 'getdbri'
-    ELSE
-      tmp_ret_val(1:size_of_in) = &
- &      intmem(keymemstart(pos):keymemstart(pos)+keymemlen(pos)-1)
-    ENDIF
-  ENDIF
-!---------------------
-END SUBROUTINE getdbri
-!-
-!=== REAL database INTERFACE
-!-
-SUBROUTINE getdbwr &
- &  (target,target_sig,status,fileorig,size_of_in,tmp_ret_val)
-!---------------------------------------------------------------------
-!- Write the REAL data into the data base
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  CHARACTER(LEN=*) :: target
-  INTEGER :: target_sig, status, fileorig, size_of_in
-  REAL,DIMENSION(:) :: tmp_ret_val
-!---------------------------------------------------------------------
-!-
-! First check if we have sufficiant space for the new key
-!-
-  IF (nb_keys+1 > keymemsize) THEN
-    CALL getin_allockeys ()
-  ENDIF
-!-
-! Fill out the items of the data base
-!-
-  nb_keys = nb_keys+1
-  keysig(nb_keys) = target_sig
-  keystr(nb_keys) = target(1:MIN(len_trim(target),30))
-  keystatus(nb_keys) = status
-  keytype(nb_keys) = 2
-  keyfromfile(nb_keys) = fileorig
-!-
-! Can we compress the data base entry ?
-!-
-  IF (     (MINVAL(tmp_ret_val) == MAXVAL(tmp_ret_val)) &
-&     .AND.(size_of_in > compress_lim)) THEN
-    keymemstart(nb_keys) = realmempos+1
-    keycompress(nb_keys) = size_of_in
-    keymemlen(nb_keys) = 1
-  ELSE
-    keymemstart(nb_keys) = realmempos+1
-    keycompress(nb_keys) = -1
-    keymemlen(nb_keys) = size_of_in
-  ENDIF
-!-
-! Before writing the actual size lets see if we have the space
-!-
-  IF (keymemstart(nb_keys)+keymemlen(nb_keys) > realmemsize) THEN
-    CALL getin_allocmem (2,keymemlen(nb_keys))
-  ENDIF
-!-
-  realmem(keymemstart(nb_keys): &
- &        keymemstart(nb_keys)+keymemlen(nb_keys)-1) = &
- &  tmp_ret_val(1:keymemlen(nb_keys))
-  realmempos = keymemstart(nb_keys)+keymemlen(nb_keys)-1
-!---------------------
-END SUBROUTINE getdbwr
-!-
-!===
-!-
-SUBROUTINE getdbrr (pos,size_of_in,target,tmp_ret_val)
-!---------------------------------------------------------------------
-!- Read the required variables in the database for REALS
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  INTEGER :: pos, size_of_in
-  CHARACTER(LEN=*) :: target
-  REAL,DIMENSION(:) :: tmp_ret_val
-!---------------------------------------------------------------------
-  IF (keytype(pos) /= 2) THEN
-    WRITE(*,*) 'FATAL ERROR : Wrong data type for keyword ',target
-    STOP 'getdbrr'
-  ENDIF
-!-
-  IF (keycompress(pos) > 0) THEN
-    IF (    (keycompress(pos) /= size_of_in) &
- &      .OR.(keymemlen(pos) /= 1) ) THEN
-      WRITE(*,*) &
- &      'FATAL ERROR : Wrong compression length for keyword ',target
-      STOP 'getdbrr'
-    ELSE
-      tmp_ret_val(1:size_of_in) = realmem(keymemstart(pos))
-    ENDIF
-  ELSE
-    IF (keymemlen(pos) /= size_of_in) THEN
-      WRITE(*,*) 'FATAL ERROR : Wrong array length for keyword ',target
-      STOP 'getdbrr'
-    ELSE
-      tmp_ret_val(1:size_of_in) = &
- &      realmem(keymemstart(pos):keymemstart(pos)+keymemlen(pos)-1)
-    ENDIF
-  ENDIF
-!---------------------
-END SUBROUTINE getdbrr
-!-
-!=== CHARACTER database INTERFACE
-!-
-SUBROUTINE getdbwc &
- &  (target,target_sig,status,fileorig,size_of_in,tmp_ret_val)
-!---------------------------------------------------------------------
-!- Write the CHARACTER data into the data base
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  CHARACTER(LEN=*) :: target
-  INTEGER :: target_sig,status,fileorig,size_of_in
-  CHARACTER(LEN=*),DIMENSION(:) :: tmp_ret_val
-!---------------------------------------------------------------------
-!-
-! First check if we have sufficiant space for the new key
-!-
-  IF (nb_keys+1 > keymemsize) THEN
-    CALL getin_allockeys ()
-  ENDIF
-!-
-! Fill out the items of the data base
-!-
-  nb_keys = nb_keys+1
-  keysig(nb_keys) = target_sig
-  keystr(nb_keys) = target(1:MIN(len_trim(target),30))
-  keystatus(nb_keys) = status
-  keytype(nb_keys) = 3
-  keyfromfile(nb_keys) = fileorig
-  keymemstart(nb_keys) = charmempos+1
-  keymemlen(nb_keys) = size_of_in
-!-
-! Before writing the actual size lets see if we have the space
-!-
-  IF (keymemstart(nb_keys)+keymemlen(nb_keys) > realmemsize) THEN
-    CALL getin_allocmem (3,keymemlen(nb_keys))
-  ENDIF
-!-
-  charmem(keymemstart(nb_keys): &
- &        keymemstart(nb_keys)+keymemlen(nb_keys)-1) = &
- &  tmp_ret_val(1:keymemlen(nb_keys))
-  charmempos = keymemstart(nb_keys)+keymemlen(nb_keys)-1
-!---------------------
-END SUBROUTINE getdbwc
-!-
-!===
-!-
-SUBROUTINE getdbrc(pos,size_of_in,target,tmp_ret_val)
-!---------------------------------------------------------------------
-!- Read the required variables in the database for CHARACTER
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  INTEGER :: pos, size_of_in
-  CHARACTER(LEN=*) :: target
-  CHARACTER(LEN=*),DIMENSION(:) :: tmp_ret_val
-!---------------------------------------------------------------------
-  IF (keytype(pos) /= 3) THEN
-    WRITE(*,*) 'FATAL ERROR : Wrong data type for keyword ',target
-    STOP 'getdbrc'
-  ENDIF
-!-
-  IF (keymemlen(pos) /= size_of_in) THEN
-    WRITE(*,*) 'FATAL ERROR : Wrong array length for keyword ',target
-    STOP 'getdbrc'
-  ELSE
-    tmp_ret_val(1:size_of_in) = &
- &    charmem(keymemstart(pos):keymemstart(pos)+keymemlen(pos)-1)
-  ENDIF
-!---------------------
-END SUBROUTINE getdbrc
-!-
-!=== LOGICAL database INTERFACE
-!-
-SUBROUTINE getdbwl &
- &  (target,target_sig,status,fileorig,size_of_in,tmp_ret_val)
-!---------------------------------------------------------------------
-!- Write the LOGICAL data into the data base
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  CHARACTER(LEN=*) :: target
-  INTEGER :: target_sig, status, fileorig, size_of_in
-  LOGICAL,DIMENSION(:) :: tmp_ret_val
-!---------------------------------------------------------------------
-!-
-! First check if we have sufficiant space for the new key
-!-
-  IF (nb_keys+1 > keymemsize) THEN
-    CALL getin_allockeys ()
-  ENDIF
-!-
-! Fill out the items of the data base
-!-
-  nb_keys = nb_keys+1
-  keysig(nb_keys) = target_sig
-  keystr(nb_keys) = target(1:MIN(len_trim(target),30))
-  keystatus(nb_keys) = status
-  keytype(nb_keys) = 4
-  keyfromfile(nb_keys) = fileorig
-  keymemstart(nb_keys) = logicmempos+1
-  keymemlen(nb_keys) = size_of_in
-!-
-! Before writing the actual size lets see if we have the space
-!-
-  IF (keymemstart(nb_keys)+keymemlen(nb_keys) > logicmemsize) THEN
-    CALL getin_allocmem (4,keymemlen(nb_keys))
-  ENDIF
-!-
-  logicmem(keymemstart(nb_keys): &
- &         keymemstart(nb_keys)+keymemlen(nb_keys)-1) = &
- &  tmp_ret_val(1:keymemlen(nb_keys))
-  logicmempos = keymemstart(nb_keys)+keymemlen(nb_keys)-1
-!---------------------
-END SUBROUTINE getdbwl
-!-
-!===
-!-
-SUBROUTINE getdbrl(pos,size_of_in,target,tmp_ret_val)
-!---------------------------------------------------------------------
-!- Read the required variables in the database for LOGICALS
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  INTEGER :: pos, size_of_in
-  CHARACTER(LEN=*) :: target
-  LOGICAL,DIMENSION(:) :: tmp_ret_val
-!---------------------------------------------------------------------
-  IF (keytype(pos) /= 4) THEN
-    WRITE(*,*) 'FATAL ERROR : Wrong data type for keyword ',target
-    STOP 'getdbrl'
-  ENDIF
-!-
-  IF (keymemlen(pos) /= size_of_in) THEN
-    WRITE(*,*) 'FATAL ERROR : Wrong array length for keyword ',target
-    STOP 'getdbrl'
-  ELSE
-    tmp_ret_val(1:size_of_in) = &
- &    logicmem(keymemstart(pos):keymemstart(pos)+keymemlen(pos)-1)
-  ENDIF
-!---------------------
-END SUBROUTINE getdbrl
-!-
 !===
 !-
@@ -2095,4 +1492,5 @@
 !-
   INTEGER :: ier
+  CHARACTER(LEN=20) :: c_tmp
 !---------------------------------------------------------------------
 !-
@@ -2100,185 +1498,173 @@
 !-
   IF (keymemsize == 0) THEN
-!-
+!---
+    WRITE (UNIT=c_tmp,FMT=*) memslabs
+!---
     ALLOCATE(keysig(memslabs),stat=ier)
     IF (ier /= 0) THEN
-      WRITE(*,*) &
- &      'getin_allockeys : Can not allocate keysig to size ', &
- &      memslabs
-      STOP
-    ENDIF
-!-
+      CALL ipslerr (3,'getin_allockeys', &
+ &     'Can not allocate keysig', &
+ &     'to size '//TRIM(ADJUSTL(c_tmp)),' ')
+    ENDIF
+!---
     ALLOCATE(keystr(memslabs),stat=ier)
     IF (ier /= 0) THEN
-      WRITE(*,*) &
- &      'getin_allockeys : Can not allocate keystr to size ', &
- &      memslabs
-      STOP
-    ENDIF
-!-
+      CALL ipslerr (3,'getin_allockeys', &
+ &     'Can not allocate keystr', &
+ &     'to size '//TRIM(ADJUSTL(c_tmp)),' ')
+    ENDIF
+!---
     ALLOCATE(keystatus(memslabs),stat=ier)
     IF (ier /= 0) THEN
-      WRITE(*,*) &
- &      'getin_allockeys : Can not allocate keystatus to size ', &
- &      memslabs
-      STOP
-    ENDIF
-!-
+      CALL ipslerr (3,'getin_allockeys', &
+ &     'Can not allocate keystatus', &
+ &     'to size '//TRIM(ADJUSTL(c_tmp)),' ')
+    ENDIF
+!---
     ALLOCATE(keytype(memslabs),stat=ier)
     IF (ier /= 0) THEN
-      WRITE(*,*) &
- &      'getin_allockeys : Can not allocate keytype to size ', &
- &      memslabs
-      STOP
-    ENDIF
-!-
+      CALL ipslerr (3,'getin_allockeys', &
+ &     'Can not allocate keytype', &
+ &     'to size '//TRIM(ADJUSTL(c_tmp)),' ')
+    ENDIF
+!---
     ALLOCATE(keycompress(memslabs),stat=ier)
     IF (ier /= 0) THEN
-      WRITE(*,*) &
- &      'getin_allockeys : Can not allocate keycompress to size ', &
- &      memslabs
-      STOP
-    ENDIF
-!-
+      CALL ipslerr (3,'getin_allockeys', &
+ &     'Can not allocate keycompress', &
+ &     'to size '//TRIM(ADJUSTL(c_tmp)),' ')
+    ENDIF
+!---
     ALLOCATE(keyfromfile(memslabs),stat=ier)
     IF (ier /= 0) THEN
-      WRITE(*,*) &
- &      'getin_allockeys : Can not allocate keyfromfile to size ', &
- &      memslabs
-      STOP
-    ENDIF
-!-
+      CALL ipslerr (3,'getin_allockeys', &
+ &     'Can not allocate keyfromfile', &
+ &     'to size '//TRIM(ADJUSTL(c_tmp)),' ')
+    ENDIF
+!---
     ALLOCATE(keymemstart(memslabs),stat=ier)
     IF (ier /= 0) THEN
-      WRITE(*,*) &
- &      'getin_allockeys : Can not allocate keymemstart to size ', &
- &      memslabs
-      STOP
-    ENDIF
-!-
+      CALL ipslerr (3,'getin_allockeys', &
+ &     'Can not allocate keymemstart', &
+ &     'to size '//TRIM(ADJUSTL(c_tmp)),' ')
+    ENDIF
+!---
     ALLOCATE(keymemlen(memslabs),stat=ier)
     IF (ier /= 0) THEN
-      WRITE(*,*) &
- &      'getin_allockeys : Can not allocate keymemlen to size ', &
- &      memslabs
-      STOP
-    ENDIF
-!-
+      CALL ipslerr (3,'getin_allockeys', &
+ &     'Can not allocate keymemlen', &
+ &     'to size '//TRIM(ADJUSTL(c_tmp)),' ')
+    ENDIF
+!---
     nb_keys = 0
     keymemsize = memslabs
     keycompress(:) = -1
-!-
+!---
   ELSE
-!-
+!---
 !-- There is something already in the memory,
 !-- we need to transfer and reallocate.
-!-
+!---
+    WRITE (UNIT=c_tmp,FMT=*) keymemsize
+!---
     ALLOCATE(tmp_str(keymemsize),stat=ier)
     IF (ier /= 0) THEN
-      WRITE(*,*) &
- &      'getin_allockeys : Can not allocate tmp_str to size ', &
- &      keymemsize
-      STOP
-    ENDIF
-!-
+      CALL ipslerr (3,'getin_allockeys', &
+ &     'Can not allocate tmp_str', &
+ &     'to size '//TRIM(ADJUSTL(c_tmp)),' ')
+    ENDIF
+!---
     ALLOCATE(tmp_int(keymemsize),stat=ier)
     IF (ier /= 0) THEN
-      WRITE(*,*) &
- &      'getin_allockeys : Can not allocate tmp_int to size ', &
- &      keymemsize
-      STOP
-    ENDIF
-!-
+      CALL ipslerr (3,'getin_allockeys', &
+ &     'Can not allocate tmp_int', &
+ &     'to size '//TRIM(ADJUSTL(c_tmp)),' ')
+    ENDIF
+!---
+    WRITE (UNIT=c_tmp,FMT=*) keymemsize+memslabs
+!---
     tmp_int(1:keymemsize) = keysig(1:keymemsize)
     DEALLOCATE(keysig)
     ALLOCATE(keysig(keymemsize+memslabs),stat=ier)
     IF (ier /= 0) THEN
-      WRITE(*,*) &
- &      'getin_allockeys : Can not allocate keysig to size ', &
- &      keymemsize+memslabs
-      STOP
+      CALL ipslerr (3,'getin_allockeys', &
+ &     'Can not allocate keysig', &
+ &     'to size '//TRIM(ADJUSTL(c_tmp)),' ')
     ENDIF
     keysig(1:keymemsize) = tmp_int(1:keymemsize)
-!-
+!---
     tmp_str(1:keymemsize) = keystr(1:keymemsize)
     DEALLOCATE(keystr)
     ALLOCATE(keystr(keymemsize+memslabs),stat=ier)
     IF (ier /= 0) THEN
-      WRITE(*,*) &
- &      'getin_allockeys : Can not allocate keystr to size ', &
- &      keymemsize+memslabs
-      STOP
+      CALL ipslerr (3,'getin_allockeys', &
+ &     'Can not allocate keystr', &
+ &     'to size '//TRIM(ADJUSTL(c_tmp)),' ')
     ENDIF
     keystr(1:keymemsize) = tmp_str(1:keymemsize)
-!-
+!---
     tmp_int(1:keymemsize) = keystatus(1:keymemsize)
     DEALLOCATE(keystatus)
     ALLOCATE(keystatus(keymemsize+memslabs),stat=ier)
     IF (ier /= 0) THEN
-      WRITE(*,*) &
- &      'getin_allockeys : Can not allocate keystatus to size ', &
- &      keymemsize+memslabs
-      STOP
+      CALL ipslerr (3,'getin_allockeys', &
+ &     'Can not allocate keystatus', &
+ &     'to size '//TRIM(ADJUSTL(c_tmp)),' ')
     ENDIF
     keystatus(1:keymemsize) = tmp_int(1:keymemsize)
-!-
+!---
     tmp_int(1:keymemsize) = keytype(1:keymemsize)
     DEALLOCATE(keytype)
     ALLOCATE(keytype(keymemsize+memslabs),stat=ier)
     IF (ier /= 0) THEN
-      WRITE(*,*) &
- &      'getin_allockeys : Can not allocate keytype to size ', &
- &      keymemsize+memslabs
-      STOP
+      CALL ipslerr (3,'getin_allockeys', &
+ &     'Can not allocate keytype', &
+ &     'to size '//TRIM(ADJUSTL(c_tmp)),' ')
     ENDIF
     keytype(1:keymemsize) = tmp_int(1:keymemsize)
-!-
+!---
     tmp_int(1:keymemsize) = keycompress(1:keymemsize)
     DEALLOCATE(keycompress)
     ALLOCATE(keycompress(keymemsize+memslabs),stat=ier)
     IF (ier /= 0) THEN
-      WRITE(*,*) &
- &      'getin_allockeys : Can not allocate keycompress to size ', &
- &      keymemsize+memslabs
-      STOP
+      CALL ipslerr (3,'getin_allockeys', &
+ &     'Can not allocate keycompress', &
+ &     'to size '//TRIM(ADJUSTL(c_tmp)),' ')
     ENDIF
     keycompress(:) = -1
     keycompress(1:keymemsize) = tmp_int(1:keymemsize)
-!-
+!---
     tmp_int(1:keymemsize) = keyfromfile(1:keymemsize)
     DEALLOCATE(keyfromfile)
     ALLOCATE(keyfromfile(keymemsize+memslabs),stat=ier)
     IF (ier /= 0) THEN
-      WRITE(*,*) &
- &      'getin_allockeys : Can not allocate keyfromfile to size ', &
- &      keymemsize+memslabs
-      STOP
+      CALL ipslerr (3,'getin_allockeys', &
+ &     'Can not allocate keyfromfile', &
+ &     'to size '//TRIM(ADJUSTL(c_tmp)),' ')
     ENDIF
     keyfromfile(1:keymemsize) = tmp_int(1:keymemsize)
-!-
+!---
     tmp_int(1:keymemsize) = keymemstart(1:keymemsize)
     DEALLOCATE(keymemstart)
     ALLOCATE(keymemstart(keymemsize+memslabs),stat=ier)
     IF (ier /= 0) THEN
-      WRITE(*,*) &
- &      'getin_allockeys : Can not allocate keymemstart to size ', &
- &      keymemsize+memslabs
-      STOP
+      CALL ipslerr (3,'getin_allockeys', &
+ &     'Can not allocate keymemstart', &
+ &     'to size '//TRIM(ADJUSTL(c_tmp)),' ')
     ENDIF
     keymemstart(1:keymemsize) = tmp_int(1:keymemsize)
-!-
+!---
     tmp_int(1:keymemsize) = keymemlen(1:keymemsize)
     DEALLOCATE(keymemlen)
     ALLOCATE(keymemlen(keymemsize+memslabs),stat=ier)
     IF (ier /= 0) THEN
-      WRITE(*,*) &
- &      'getin_allockeys : Can not allocate keymemlen to size ', &
- &      keymemsize+memslabs
-      STOP
+      CALL ipslerr (3,'getin_allockeys', &
+ &     'Can not allocate keymemlen', &
+ &     'to size '//TRIM(ADJUSTL(c_tmp)),' ')
     ENDIF
     keymemlen(1:keymemsize) = tmp_int(1:keymemsize)
-!-
+!---
     keymemsize = keymemsize+memslabs
-!-
+!---
     DEALLOCATE(tmp_int)
     DEALLOCATE(tmp_str)
@@ -2292,13 +1678,9 @@
 !---------------------------------------------------------------------
 !- Allocate the memory of the data base for all 4 types of memory
-!-
-!- 1 = INTEGER
-!- 2 = REAL
-!- 3 = CHAR
-!- 4 = LOGICAL
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  INTEGER :: type, len_wanted
+!- INTEGER / REAL / CHAR / LOGICAL
+!---------------------------------------------------------------------
+  IMPLICIT NONE
+!-
+  INTEGER :: type,len_wanted
 !-
   INTEGER,ALLOCATABLE :: tmp_int(:)
